%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################

count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;

g_cur=0;
U(count_cell)=0;

Tsat_cur=Tsat(count_channel,count_w);
Tsat_previous=Tsat_prev(count_channel,count_w);

%top
count_neigh=(count_h)*n_a+(count_w-1)*n_l+count_l;
eff_conductance=inv(inv(cell_info(count_cell).top)+inv(cell_info(count_neigh).bottom));
G(count_cell,count_neigh)=-1*eff_conductance;
g_cur=g_cur+eff_conductance;
prev_neigh_value=Ubottom(count_neigh)/Tsat_previous;
Ubottom(count_neigh)=eff_conductance*Tsat_cur;
G(count_neigh,count_neigh)=G(count_neigh,count_neigh)-prev_neigh_value+eff_conductance;

%bottom
count_neigh=(count_h-2)*n_a+(count_w-1)*n_l+count_l;
eff_conductance=inv(inv(cell_info(count_cell).bottom)+inv(cell_info(count_neigh).top));
G(count_cell,count_neigh)=-1*eff_conductance;
g_cur=g_cur+eff_conductance;
prev_neigh_value=Utop(count_neigh)/Tsat_previous;
Utop(count_neigh)=eff_conductance*Tsat_cur;
G(count_neigh,count_neigh)=G(count_neigh,count_neigh)-prev_neigh_value+eff_conductance;



%east
count_neigh=(count_h-1)*n_a+(count_w-1)*n_l+count_l+1;
eff_conductance=inv(inv(cell_info(count_cell).east)+inv(cell_info(count_neigh).west));
G(count_cell,count_neigh)=-1*eff_conductance;
g_cur=g_cur+eff_conductance;
prev_neigh_value=Uwest(count_neigh)/Tsat_previous;
Uwest(count_neigh)=eff_conductance*Tsat_cur;
G(count_neigh,count_neigh)=G(count_neigh,count_neigh)-prev_neigh_value+eff_conductance;


%west
count_neigh=(count_h-1)*n_a+(count_w-1)*n_l+count_l-1;
eff_conductance=inv(inv(cell_info(count_cell).west)+inv(cell_info(count_neigh).east));
G(count_cell,count_neigh)=-1*eff_conductance;
g_cur=g_cur+eff_conductance;
prev_neigh_value=Ueast(count_neigh)/Tsat_previous;
Ueast(count_neigh)=eff_conductance*Tsat_cur;
G(count_neigh,count_neigh)=G(count_neigh,count_neigh)-prev_neigh_value+eff_conductance;

%convection terms

G(count_cell,count_cell)=cell_info(count_cell).north;

if count_w>1
    G(count_cell,count_cell-n_l)=-cell_info(count_cell).south;
else
    U(count_cell)=cell_info(count_cell).south*xin;
end





U(count_cell)=U(count_cell)-g_cur*Tsat_cur;
C(count_cell,count_cell)=cell_info(count_cell).cap;