%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################

count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;
count_ch=count_l/2;

rho_g=refpropm('D','T',Tin,'Q',1,ref)*1e-18;
rho_l=refpropm('D','T',Tin,'Q',0,ref)*1e-18;

x_cur=X(count_cell);
x_prev=X0(count_cell);
x_dot=(x_cur-x_prev)/h_step;

delV=channel_width*channel_height*w;

M_dot=delV*((rho_g*rho_l)*(rho_l-rho_g)*x_dot/(x_cur*rho_l+(1-x_cur)*rho_g)^2);

if count_w==1
    FM_south=FM_in_set(count_ch);
else
    FM_south=FM_values(count_channel,count_w-1);
end
FM_values(count_channel,count_w)=FM_south+M_dot;
