%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################

function data=extract_refpropdata(ref,datatype);

if strcmp(datatype,'molecularweight')
    n=6;
elseif strcmp(datatype,'criticalpressure')
    n=10;
else
    disp(['Error! function extract_refpropdata cannot understand the datatype ', datatype]);
    return;
end


refdata=importdata(['C:\Program Files (x86)\REFPROP\fluids\',ref],' ',n);

data_str=refdata{n};

end_flag=1;
i=1;
data=[];
while(end_flag)
    if strcmp(data_str(i),' ')
        end_flag=0;
    else
        data=[data data_str(i)];
        i=i+1;
    end
end

data=str2num(data);
