%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################
temp=1;

%% POWER TRACES FROM JIE

%% 2D - CORE AND L2 IN THE SAME LAYER

%DEFAULT VALUES
core_power_2D=1.33*ones(16,100);
sys_io_power_2D=0*ones(1,100);
l2_power_2D=0.97*ones(16,100);
mc_power_2D=5.9*ones(1,100);

% % % % % % %FROM FILE - COMMENT IF YOU DON'T WANT THIS
% % % % % % power_filename_2D='2D_onchip_fluidanimate.txt';
% % % % % % power_full_2D=textread(power_filename_2D);
% % % % % % core_power_2D=power_full_2D(:,1:16)';
% % % % % % l2_power_2D=power_full_2D(:,17:32)';
% % % % % % mc_power_2D=power_full_2D(:,33)';
% % % % % % sys_io_power_2D=power_full_2D(:,34)';

%% 3D - CORE AND L2 IN DIFFERENT LAYERS

%DEFAULT VALUES
core_power_3D=1.33*ones(16,100);
sys_io_power_3D=0*ones(1,100);
l2_power_3D=0.97*ones(16,100);
mc_power_3D=5.9*ones(1,100);

%FROM FILE - COMMENT IF YOU DON'T WANT THIS
% % % % % power_filename_3D_core='3D_stackl2_aggressive_fluidanimate_core.txt';  %'3D_stackl2_fluidanimate_core.txt'
% % % % % power_filename_3D_l2='3D_stackl2_aggressive_fluidanimate_L2.txt';  %'3D_stackl2_fluidanimate_L2.txt'
% % % % % power_full_3D_core=textread(power_filename_3D_core);
% % % % % power_full_3D_l2=textread(power_filename_3D_l2);
% % % % % core_power_3D=power_full_3D_core(:,1:16)';
% % % % % l2_power_3D=power_full_3D_l2(:,1:16)';
% % % % % mc_power_3D=power_full_3D_l2(:,17)';
% % % % % sys_io_power_3D=power_full_3D_l2(:,18)';

%%

if strcmp(distribution,'hotspot')
    
% %%%%%%%%%%%%%%%% OLD TEST %%%%%%%%%%%%%%%%%%%%%%%%%%%
% L01_D01=struct('name','HostpotArea','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 0.000, 'power', L*2000*1e-8*[50 250]);%Unit: L2_BANK1 %%1e-6*L*W
% L01_D02=struct('name','PartialBackground1','layer',current_source_layer, 'length',L, 'width',4000.0, 'x', 0.000, 'y', -1234234000.000, 'power', L*125000*1e-8*[50  50]);%Unit: L2_BANK2
% L01_D03=struct('name','PartialBackground2','layer',current_source_layer, 'length',L, 'width',8000.0, 'x', 0.000, 'y', 2000.0, 'power',L*8000*1e-8*[50  50]);%Unit: L2_BANK3
% L01_D04=struct('name','L2_B4','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -8400.000, 'y', -3000.000, 'power', 0.120);%Unit: L2_BANK4

%%%%%%%%%%%%%%%%% MIDDLE BLOCK SWITCHING %%%%%%%%%%%%%%%%%%%%%%%%%%%
% L01_D01=struct('name','HostpotArea','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 4000.0, 'power', L*2000*1e-8*[50 50 50 50 50 250 50 250 50 250]);%Unit: L2_BANK1 %%1e-6*L*W
% L01_D02=struct('name','PartialBackground1','layer',current_source_layer, 'length',L, 'width',4000.0, 'x', 0.000, 'y', 0.000, 'power', L*4000*1e-8*[50  50 50 50 50  50 50  50 50 50]);%Unit: L2_BANK2
% L01_D03=struct('name','PartialBackground2','layer',current_source_layer, 'length',L, 'width',4000.0, 'x', 0.000, 'y', 6000.0, 'power',L*4000*1e-8*[50  50 50 50 50  50 50  50 50 50]);%Unit: L2_BANK3
% L01_D04=struct('name','L2_B4','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -8400.000, 'y', -3000.000, 'power', 0.120);%Unit: L2_BANK4


%%%%%%%%%%%%%%% MIDDLE BLOCK SWITCHING AND THEN FIRST BLOCK SWITCHING%%%%%%%%%%%%%%%%%%%%%%%%%%%
L01_D01=struct('name','HostpotArea1','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 0.0000, 'power', L*2000*1e-8*[125 0 0 0 250 250 250 250 0 0 0 0]);%Unit: L2_BANK1 %%1e-6*L*W
L01_D02=struct('name','HostpotArea2','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 4000.0, 'power', L*2000*1e-8*[75 0 0 0 250 250 250 250 0 0 0 0 ]);%Unit: L2_BANK1 %%1e-6*L*W
L01_D03=struct('name','PartialBackground1','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 2000.0, 'power', L*2000*1e-8*[20 0 0 0 50 50 50 50 0 0 0 0]);%Unit: L2_BANK2
L01_D04=struct('name','PartialBackground2','layer',current_source_layer, 'length',L, 'width',4000.0, 'x', 0.000, 'y', 6000.0, 'power', L*4000*1e-8*[20 0 0 0 50 50 50 50 0 0 0 0]);%Unit: L2_BANK3


% %%%%%%%%%%%%%%%% MIDDLE BLOCK SWITCHING AND THEN FIRST BLOCK CONTINUOUS%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L01_D01=struct('name','HostpotArea1','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 0.0000, 'power', L*2000*1e-8*[50 50 50 50 50  50 50 50 50 50     50 50 50 50 50  250 250 250 250 250]);%Unit: L2_BANK1 %%1e-6*L*W
% L01_D02=struct('name','HostpotArea2','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 4000.0, 'power', L*2000*1e-8*[50 50 50 50 50  250 50 250 50 250  50 50 50 50 50  50 50 50 50 50   ]);%Unit: L2_BANK1 %%1e-6*L*W
% L01_D03=struct('name','PartialBackground1','layer',current_source_layer, 'length',L, 'width',2000.0, 'x', 0.000, 'y', 2000.0, 'power', L*2000*1e-8*[50 50 50 50 50  50 50 50 50 50  50 50 50 50 50  50 50 50 50 50]);%Unit: L2_BANK2
% L01_D04=struct('name','PartialBackground2','layer',current_source_layer, 'length',L, 'width',4000.0, 'x', 0.000, 'y', 6000.0, 'power', L*4000*1e-8*[50 50 50 50 50  50 50 50 50 50  50 50 50 50 50  50 50 50 50 50]);%Unit: L2_BANK3

L01_D05=struct('name','C1','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -6000.000, 'power', 4.000);%Unit: C1
L01_D06=struct('name','C2','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -6000.000, 'power', 4.000);%Unit: C2
L01_D07=struct('name','C3','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -6000.000, 'power', 4.000);%Unit: C3
L01_D08=struct('name','C4','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -6000.000, 'power', 4.000);%Unit: C4
L01_D09=struct('name','C5','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -3000.000, 'power', 4.000);%Unit: C5
L01_D010=struct('name','C6','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C6
L01_D011=struct('name','C7','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 4.000);%Unit: C7
L01_D012=struct('name','C8','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -3000.000, 'power', 4.000);%Unit: C8
L01_D013=struct('name','C9','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C9
L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);



elseif strcmp(distribution,'background')

% %%%%%%%%%%%%%%%%% FOR HEFF TEST %%%%%%%%%%%%%%%%%%%%%%%%%%%    
% L01_D01=struct('name','Background','layer',current_source_layer, 'length',L, 'width',W, 'x', 0.000, 'y', 0, 'power', L*W*1e-8*[50 50]);%Unit: L2_BANK1

%%%%%%%%%%%%%%%%% OLD TEST %%%%%%%%%%%%%%%%%%%%%%%%%%%    
% L01_D01=struct('name','Background','layer',current_source_layer, 'length',L, 'width',W, 'x', 0.000, 'y', 0, 'power', L*W*1e-8*[50 50 50 50 50  50 50 50 50 50]);%Unit: L2_BANK1

%%%%%%%%%%%%%%%%% LONG TEST %%%%%%%%%%%%%%%%%%%%%%%%%%%
L01_D01=struct('name','Background','layer',current_source_layer, 'length',L, 'width',W, 'x', 0.000, 'y', 0, 'power', L*W*1e-8*[45.25 0 0 0 25 25 25 25 0 0 0 0]); %[50 50 50 50 50  50 50 50 50 50  50 50 50 50 50  50 50 50 50 50  50 50 50 50 50  50 50 50 50 50]);%Unit: L2_BANK1

L01_D02=struct('name','L2_B2','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -8400.000, 'y', -4800.000, 'power', 0.120);%Unit: L2_BANK2
L01_D03=struct('name','L2_B3','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -3000.000, 'y', -3000.000, 'power', 0.120);%Unit: L2_BANK3
L01_D04=struct('name','L2_B4','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -8400.000, 'y', -3000.000, 'power', 0.120);%Unit: L2_BANK4
L01_D05=struct('name','C1','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -6000.000, 'power', 4.000);%Unit: C1
L01_D06=struct('name','C2','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -6000.000, 'power', 4.000);%Unit: C2
L01_D07=struct('name','C3','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -6000.000, 'power', 4.000);%Unit: C3
L01_D08=struct('name','C4','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -6000.000, 'power', 4.000);%Unit: C4
L01_D09=struct('name','C5','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -3000.000, 'power', 4.000);%Unit: C5
L01_D010=struct('name','C6','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C6
L01_D011=struct('name','C7','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 4.000);%Unit: C7
L01_D012=struct('name','C8','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -3000.000, 'power', 4.000);%Unit: C8
L01_D013=struct('name','C9','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C9
L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

elseif strcmp(distribution,'etienne7by5_background')

src_l=2540;
src_w=2540;
x_index=[1 2 3 4 5 6 7];
y_index=[1 2 3 4 5];
x_loc=(x_index-1)*src_l;
y_loc=(y_index-1)*src_w;
load extractedDataR236_G933_Tsat31;
qb=q_b*1e-4;

L01_D01 =struct('name','H11','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,1)]); 
L01_D02 =struct('name','H12','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,2)]); 
L01_D03 =struct('name','H13','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,3)]); 
L01_D04 =struct('name','H14','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,4)]); 
L01_D05 =struct('name','H15','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,5)]); 
L01_D06 =struct('name','H16','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,6)]); 
L01_D07 =struct('name','H17','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,7)]); 
L01_D08 =struct('name','H21','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,1)]); 
L01_D09 =struct('name','H22','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,2)]); 
L01_D010=struct('name','H23','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,3)]); 
L01_D011=struct('name','H24','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,4)]); 
L01_D012=struct('name','H25','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,5)]); 
L01_D013=struct('name','H26','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,6)]); 
L01_D014=struct('name','H27','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,7)]); 
L01_D015=struct('name','H31','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,1)]); 
L01_D016=struct('name','H32','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,2)]); 
L01_D017=struct('name','H33','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,3)]); 
L01_D018=struct('name','H34','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,4)]); 
L01_D019=struct('name','H35','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,5)]); 
L01_D020=struct('name','H36','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,6)]); 
L01_D021=struct('name','H37','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,7)]); 
L01_D022=struct('name','H41','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,1)]); 
L01_D023=struct('name','H42','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,2)]); 
L01_D024=struct('name','H43','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,3)]); 
L01_D025=struct('name','H44','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,4)]); 
L01_D026=struct('name','H45','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,5)]); 
L01_D027=struct('name','H46','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,6)]); 
L01_D028=struct('name','H47','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,7)]); 
L01_D029=struct('name','H51','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,1)]); 
L01_D030=struct('name','H52','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,2)]); 
L01_D031=struct('name','H53','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,3)]); 
L01_D032=struct('name','H54','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,4)]); 
L01_D033=struct('name','H55','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,5)]); 
L01_D034=struct('name','H56','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,6)]); 
L01_D035=struct('name','H57','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,7)]);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

elseif strcmp(distribution,'etienne7by5_hotspot')

src_l=2540;
src_w=2540;
x_index=[1 2 3 4 5 6 7];
y_index=[1 2 3 4 5];
x_loc=(x_index-1)*src_l;
y_loc=(y_index-1)*src_w;

load extractedDataR245fa_G713_hotspot34;
qb=q_b*1e-4;

L01_D01 =struct('name','H11','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,1)]); 
L01_D02 =struct('name','H12','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,2)]); 
L01_D03 =struct('name','H13','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,3)]); 
L01_D04 =struct('name','H14','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,4)]); 
L01_D05 =struct('name','H15','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,5)]); 
L01_D06 =struct('name','H16','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,6)]); 
L01_D07 =struct('name','H17','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(1), 'power', src_l*src_w*1e-8*[qb(1,7)]); 
L01_D08 =struct('name','H21','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,1)]); 
L01_D09 =struct('name','H22','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,2)]); 
L01_D010=struct('name','H23','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,3)]); 
L01_D011=struct('name','H24','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,4)]); 
L01_D012=struct('name','H25','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,5)]); 
L01_D013=struct('name','H26','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,6)]); 
L01_D014=struct('name','H27','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(2), 'power', src_l*src_w*1e-8*[qb(2,7)]); 
L01_D015=struct('name','H31','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,1)]); 
L01_D016=struct('name','H32','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,2)]); 
L01_D017=struct('name','H33','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,3)]); 
L01_D018=struct('name','H34','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,4)]); 
L01_D019=struct('name','H35','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,5)]); 
L01_D020=struct('name','H36','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,6)]); 
L01_D021=struct('name','H37','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(3), 'power', src_l*src_w*1e-8*[qb(3,7)]); 
L01_D022=struct('name','H41','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,1)]); 
L01_D023=struct('name','H42','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,2)]); 
L01_D024=struct('name','H43','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,3)]); 
L01_D025=struct('name','H44','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,4)]); 
L01_D026=struct('name','H45','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,5)]); 
L01_D027=struct('name','H46','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,6)]); 
L01_D028=struct('name','H47','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(4), 'power', src_l*src_w*1e-8*[qb(4,7)]); 
L01_D029=struct('name','H51','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(1), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,1)]); 
L01_D030=struct('name','H52','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(2), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,2)]); 
L01_D031=struct('name','H53','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(3), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,3)]); 
L01_D032=struct('name','H54','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(4), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,4)]); 
L01_D033=struct('name','H55','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(5), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,5)]); 
L01_D034=struct('name','H56','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(6), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,6)]); 
L01_D035=struct('name','H57','layer',current_source_layer, 'length',src_l, 'width',src_w, 'x', x_loc(7), 'y', y_loc(5), 'power', src_l*src_w*1e-8*[qb(5,7)]);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

elseif strcmp(distribution,'4regions')

L01_D01=struct('name','Background1','layer',current_source_layer, 'length',L/2, 'width',W/2, 'x', 0.000, 'y', 0, 'power', L*W*1e-8*0.25*[50 50 50 50 0 0 0 0 50 50 50 50]);%Unit: L2_BANK1
L01_D02=struct('name','Background2','layer',current_source_layer, 'length',L/2, 'width',W/2, 'x', 5000.000, 'y', 0, 'power', L*W*1e-8*0.25*[0 0 0 0 25 25 25 25 0 0 0 0]);%Unit: L2_BANK2
L01_D03=struct('name','Background3','layer',current_source_layer, 'length',L/2, 'width',W/2, 'x', 0.000, 'y', 5000.0, 'power', L*W*1e-8*0.25*[0 0 0 0  75 75 75 75  0 0 0 0]);%Unit: L2_BANK3
L01_D04=struct('name','Background4','layer',current_source_layer, 'length',L/2, 'width',W/2, 'x', 5000.000, 'y', 5000.0, 'power', L*W*1e-8*0.25*[50 50 50 50 0 0 0 0 50 50 50 50]);%Unit: L2_BANK4
L01_D05=struct('name','C1','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -6000.000, 'power', 4.000);%Unit: C1
L01_D06=struct('name','C2','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -6000.000, 'power', 4.000);%Unit: C2
L01_D07=struct('name','C3','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -6000.000, 'power', 4.000);%Unit: C3
L01_D08=struct('name','C4','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -6000.000, 'power', 4.000);%Unit: C4
L01_D09=struct('name','C5','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -3000.000, 'power', 4.000);%Unit: C5
L01_D010=struct('name','C6','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C6
L01_D011=struct('name','C7','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 4.000);%Unit: C7
L01_D012=struct('name','C8','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -3000.000, 'power', 4.000);%Unit: C8
L01_D013=struct('name','C9','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C9
L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

elseif strcmp(distribution,'CORE')
sys_io=200;
core_l=2400;
core_w=1625;



L01_D01=struct('name','Core01','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l), 'y', (sys_io+0*core_w), 'power', core_power_3D(1,:));
L01_D02=struct('name','Core02','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l), 'y', (sys_io+0*core_w), 'power', core_power_3D(2,:));
L01_D03=struct('name','Core03','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l), 'y', (sys_io+0*core_w), 'power', core_power_3D(3,:));
L01_D04=struct('name','Core04','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l), 'y', (sys_io+0*core_w), 'power', core_power_3D(4,:));
L01_D05=struct('name','Core05','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l), 'y', (sys_io+1*core_w), 'power', core_power_3D(5,:));
L01_D06=struct('name','Core06','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l), 'y', (sys_io+1*core_w), 'power', core_power_3D(6,:));
L01_D07=struct('name','Core07','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l), 'y', (sys_io+1*core_w), 'power', core_power_3D(7,:));
L01_D08=struct('name','Core08','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l), 'y', (sys_io+1*core_w), 'power', core_power_3D(8,:));
L01_D09=struct('name','Core09','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l), 'y', (sys_io+2*core_w), 'power', core_power_3D(9,:));
L01_D010=struct('name','Core10','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l), 'y', (sys_io+2*core_w), 'power', core_power_3D(10,:));
L01_D011=struct('name','Core11','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l), 'y', (sys_io+2*core_w), 'power', core_power_3D(11,:));
L01_D012=struct('name','Core12','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l), 'y', (sys_io+2*core_w), 'power', core_power_3D(12,:));
L01_D013=struct('name','Core13','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l), 'y', (sys_io+3*core_w), 'power', core_power_3D(13,:));
L01_D014=struct('name','Core14','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l), 'y', (sys_io+3*core_w), 'power', core_power_3D(14,:));
L01_D015=struct('name','Core15','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l), 'y', (sys_io+3*core_w), 'power', core_power_3D(15,:));
L01_D016=struct('name','Core16','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l), 'y', (sys_io+3*core_w), 'power', core_power_3D(16,:));
L01_D017=struct('name','sys_io','layer',current_source_layer, 'length',L, 'width',sys_io, 'x', 0, 'y', 0, 'power', sys_io_power_3D(1,:));%Unit: L2_3

L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);



elseif strcmp(distribution,'L2')
mc=375;
l2_l=2400;
l2_w=1300;


L01_D01=struct('name','L201','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (0*l2_l), 'y',(1*mc+0*l2_w), 'power', l2_power_3D(1,:));
L01_D02=struct('name','L202','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*l2_l), 'y',(1*mc+0*l2_w), 'power', l2_power_3D(2,:));
L01_D03=struct('name','L203','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*l2_l), 'y',(1*mc+0*l2_w), 'power', l2_power_3D(3,:));
L01_D04=struct('name','L204','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*l2_l), 'y',(1*mc+0*l2_w), 'power', l2_power_3D(4,:));
L01_D05=struct('name','L205','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (0*l2_l), 'y',(2*mc+1*l2_w), 'power', l2_power_3D(5,:));
L01_D06=struct('name','L206','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*l2_l), 'y',(2*mc+1*l2_w), 'power', l2_power_3D(6,:));
L01_D07=struct('name','L207','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*l2_l), 'y',(2*mc+1*l2_w), 'power', l2_power_3D(7,:));
L01_D08=struct('name','L208','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*l2_l), 'y',(2*mc+1*l2_w), 'power', l2_power_3D(8,:));
L01_D09=struct('name','L209','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (0*l2_l), 'y',(3*mc+2*l2_w), 'power', l2_power_3D(9,:));
L01_D010=struct('name','L210','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*l2_l), 'y',(3*mc+2*l2_w), 'power', l2_power_3D(10,:));
L01_D011=struct('name','L211','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*l2_l), 'y',(3*mc+2*l2_w), 'power', l2_power_3D(11,:));
L01_D012=struct('name','L212','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*l2_l), 'y',(3*mc+2*l2_w), 'power', l2_power_3D(12,:));
L01_D013=struct('name','L213','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (0*l2_l), 'y',(4*mc+3*l2_w), 'power', l2_power_3D(13,:));
L01_D014=struct('name','L214','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*l2_l), 'y',(4*mc+3*l2_w), 'power', l2_power_3D(14,:));
L01_D015=struct('name','L215','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*l2_l), 'y',(4*mc+3*l2_w), 'power', l2_power_3D(15,:));
L01_D016=struct('name','L216','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*l2_l), 'y',(4*mc+3*l2_w), 'power', l2_power_3D(16,:));
L01_D017=struct('name','mc1','layer',current_source_layer, 'length', L, 'width',mc, 'x', 0, 'y', (0*mc+0*l2_w), 'power', mc_power_3D(1,:)/4);%Unit: L2_3
L01_D018=struct('name','mc2','layer',current_source_layer, 'length', L, 'width',mc, 'x', 0, 'y', (1*mc+1*l2_w), 'power', mc_power_3D(1,:)/4);%Unit: L2_4
L01_D019=struct('name','mc3','layer',current_source_layer, 'length', L, 'width',mc, 'x', 0, 'y', (2*mc+2*l2_w), 'power', mc_power_3D(1,:)/4);%Unit: L2_5
L01_D020=struct('name','mc4','layer',current_source_layer, 'length', L, 'width',mc, 'x', 0, 'y', (3*mc+3*l2_w), 'power', mc_power_3D(1,:)/4);%Unit: L2_6

L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);



elseif strcmp(distribution,'COREL2_OnChipMC')
core_l=1625;
core_w=2400;
l2_l=1300;
l2_w=2400;
mc=1230.8;
sys_io=169.2;



L01_D01=struct('name','Core01','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l + 0*l2_l), 'y', (sys_io+0*core_w), 'power', core_power_2D(1,:));
L01_D02=struct('name','Core02','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l + 1*l2_l), 'y', (sys_io+0*core_w), 'power', core_power_2D(2,:));
L01_D03=struct('name','Core03','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l + 2*l2_l), 'y', (sys_io+0*core_w), 'power', core_power_2D(3,:));
L01_D04=struct('name','Core04','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l + 3*l2_l), 'y', (sys_io+0*core_w), 'power', core_power_2D(4,:));
L01_D05=struct('name','Core05','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l + 0*l2_l), 'y', (sys_io+1*core_w), 'power', core_power_2D(5,:));
L01_D06=struct('name','Core06','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l + 1*l2_l), 'y', (sys_io+1*core_w), 'power', core_power_2D(6,:));
L01_D07=struct('name','Core07','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l + 2*l2_l), 'y', (sys_io+1*core_w), 'power', core_power_2D(7,:));
L01_D08=struct('name','Core08','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l + 3*l2_l), 'y', (sys_io+1*core_w), 'power', core_power_2D(8,:));
L01_D09=struct('name','Core09','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l + 0*l2_l), 'y', (sys_io+2*core_w), 'power', core_power_2D(9,:));
L01_D010=struct('name','Core10','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l + 1*l2_l), 'y', (sys_io+2*core_w), 'power', core_power_2D(10,:));
L01_D011=struct('name','Core11','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l + 2*l2_l), 'y', (sys_io+2*core_w), 'power', core_power_2D(11,:));
L01_D012=struct('name','Core12','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l + 3*l2_l), 'y', (sys_io+2*core_w), 'power', core_power_2D(12,:));
L01_D013=struct('name','Core13','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (0*core_l + 0*l2_l), 'y', (sys_io+3*core_w), 'power', core_power_2D(13,:));
L01_D014=struct('name','Core14','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (1*core_l + 1*l2_l), 'y', (sys_io+3*core_w), 'power', core_power_2D(14,:));
L01_D015=struct('name','Core15','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (2*core_l + 2*l2_l), 'y', (sys_io+3*core_w), 'power', core_power_2D(15,:));
L01_D016=struct('name','Core16','layer',current_source_layer, 'length',core_l, 'width',core_w, 'x', (3*core_l + 3*l2_l), 'y', (sys_io+3*core_w), 'power', core_power_2D(16,:));

L01_D017=struct('name','L201','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*core_l + 0*l2_l), 'y',(sys_io+0*l2_w), 'power', l2_power_2D(1,:));
L01_D018=struct('name','L202','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*core_l + 1*l2_l), 'y',(sys_io+0*l2_w), 'power', l2_power_2D(2,:));
L01_D019=struct('name','L203','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*core_l + 2*l2_l), 'y',(sys_io+0*l2_w), 'power', l2_power_2D(3,:));
L01_D020=struct('name','L204','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (4*core_l + 3*l2_l), 'y',(sys_io+0*l2_w), 'power', l2_power_2D(4,:));
L01_D021=struct('name','L205','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*core_l + 0*l2_l), 'y',(sys_io+1*l2_w), 'power', l2_power_2D(5,:));
L01_D022=struct('name','L206','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*core_l + 1*l2_l), 'y',(sys_io+1*l2_w), 'power', l2_power_2D(6,:));
L01_D023=struct('name','L207','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*core_l + 2*l2_l), 'y',(sys_io+1*l2_w), 'power', l2_power_2D(7,:));
L01_D024=struct('name','L208','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (4*core_l + 3*l2_l), 'y',(sys_io+1*l2_w), 'power', l2_power_2D(8,:));
L01_D025=struct('name','L209','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*core_l + 0*l2_l), 'y',(sys_io+2*l2_w), 'power', l2_power_2D(9,:));
L01_D026=struct('name','L210','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*core_l + 1*l2_l), 'y',(sys_io+2*l2_w), 'power', l2_power_2D(10,:));
L01_D027=struct('name','L211','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*core_l + 2*l2_l), 'y',(sys_io+2*l2_w), 'power', l2_power_2D(11,:));
L01_D028=struct('name','L212','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (4*core_l + 3*l2_l), 'y',(sys_io+2*l2_w), 'power', l2_power_2D(12,:));
L01_D029=struct('name','L213','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (1*core_l + 0*l2_l), 'y',(sys_io+3*l2_w), 'power', l2_power_2D(13,:));
L01_D030=struct('name','L214','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (2*core_l + 1*l2_l), 'y',(sys_io+3*l2_w), 'power', l2_power_2D(14,:));
L01_D031=struct('name','L215','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (3*core_l + 2*l2_l), 'y',(sys_io+3*l2_w), 'power', l2_power_2D(15,:));
L01_D032=struct('name','L216','layer',current_source_layer, 'length',l2_l, 'width',l2_w, 'x', (4*core_l + 3*l2_l), 'y',(sys_io+3*l2_w), 'power', l2_power_2D(16,:));

L01_D033=struct('name','MC','layer',current_source_layer, 'length', L, 'width',mc, 'x', 0, 'y', (sys_io+4*l2_w), 'power', mc_power_2D(1,:));%Unit: L2_3
L01_D034=struct('name','sys_io','layer',current_source_layer, 'length',L, 'width',sys_io, 'x', 0, 'y', 0, 'power', sys_io_power_2D(1,:));%Unit: L2_3


L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);


elseif strcmp(distribution,'uniform4')
L01_D01=struct('name','L2_B1','layer',current_source_layer, 'length',L, 'width',W, 'x', 0.000, 'y', 0.0000, 'power', 40);%Unit: L2_BANK1
L01_D02=struct('name','L2_B2','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -8400.000, 'y', -4800.000, 'power', 0.120);%Unit: L2_BANK2
L01_D03=struct('name','L2_B3','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -3000.000, 'y', -3000.000, 'power', 0.120);%Unit: L2_BANK3
L01_D04=struct('name','L2_B4','layer',current_source_layer, 'length',1200.000, 'width',3000.000, 'x', -8400.000, 'y', -3000.000, 'power', 0.120);%Unit: L2_BANK4
L01_D05=struct('name','C1','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -6000.000, 'power', 4.000);%Unit: C1
L01_D06=struct('name','C2','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -6000.000, 'power', 4.000);%Unit: C2
L01_D07=struct('name','C3','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -6000.000, 'power', 4.000);%Unit: C3
L01_D08=struct('name','C4','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -6000.000, 'power', 4.000);%Unit: C4
L01_D09=struct('name','C5','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -1200.000, 'y', -3000.000, 'power', 4.000);%Unit: C5
L01_D010=struct('name','C6','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C6
L01_D011=struct('name','C7','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 4.000);%Unit: C7
L01_D012=struct('name','C8','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -3000.000, 'power', 4.000);%Unit: C8
L01_D013=struct('name','C9','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C9
L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

elseif strcmp(distribution,'niagara_core')
L01_D01=struct('name','Core 0','layer',current_source_layer, 'length',2400, 'width',4500.0, 'x', 0, 'y', 0, 'power', 3.3);
L01_D02=struct('name','Core 1','layer',current_source_layer, 'length',2400, 'width',4500.0, 'x', 2400, 'y', 0, 'power', 3.3);
L01_D03=struct('name','Core 2','layer',current_source_layer, 'length',2400, 'width',4500.000, 'x', 5200, 'y', 0, 'power', 3.3);
L01_D04=struct('name','Core 3','layer',current_source_layer, 'length',2400, 'width',4500.000, 'x', 7600, 'y', 0, 'power', 3.3);
L01_D05=struct('name','Core 4','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 0, 'y', 6500, 'power', 3.3);
L01_D06=struct('name','Core 5','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 2400, 'y', 6500, 'power', 3.3);
L01_D07=struct('name','Core 6','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 5200, 'y', 6500, 'power', 3.3);
L01_D08=struct('name','Core 7','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 7600, 'y', 6500, 'power', 3.3);
L01_D09=struct('name','Cross Bar','layer',current_source_layer, 'length',4400, 'width',2000, 'x', 2800, 'y', 4500, 'power', 3.8);
L01_D010=struct('name','FPU','layer',current_source_layer, 'length',1000.000, 'width',2000.000, 'x', 7200.000, 'y', 4500.000, 'power', 0.7);
L01_D011=struct('name','Mem_0','layer',current_source_layer, 'length', 1800, 'width', 2000, 'x',0,'y',4500, 'power',0.2);
L01_D012=struct('name','Mem_1','layer',current_source_layer, 'length', 1800, 'width', 2000, 'x',8200,'y',4500, 'power',0.2);
L01_D013=struct('name','CLK','layer',current_source_layer, 'length', 1000, 'width',2000, 'x',1800,'y',4500, 'power',0.13);


L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);



elseif strcmp(distribution,'niagara_memory')
L01_D01=struct('name','L2_0','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 0, 'y',0.000, 'power', 1.9);
L01_D02=struct('name','L2_1','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 6500.000, 'y', 0.000, 'power', 1.9);
L01_D03=struct('name','L2_2','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 0.000, 'y', 5500.000, 'power', 1.9);
L01_D04=struct('name','L2_3','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 6500.000, 'y', 5500.000, 'power', 1.9);
L01_D05=struct('name','Buf 0','layer',current_source_layer, 'length',2800.000, 'width',1900.000, 'x', 3700.000, 'y', 5500.000, 'power', 1);
L01_D06=struct('name','Buf 1','layer',current_source_layer, 'length',2800.000, 'width',1900.000, 'x', 3500.000, 'y', 3600.000, 'power', 1);
L01_D07=struct('name','Tag 01','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500.000, 'y', 0, 'power', 0.7);
L01_D08=struct('name','Tag 11','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500.000, 'y', 1800, 'power', 0.7);
L01_D09=struct('name','Tag 21','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500.000, 'y', 7400, 'power', 0.7);
L01_D010=struct('name','Tag 31','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500.000, 'y', 9200, 'power', 0.7);

L01_D011=struct('name','C7','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 4.000);%Unit: C7
L01_D012=struct('name','C8','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -3000.000, 'power', 4.000);%Unit: C8
L01_D013=struct('name','C9','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C9
L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

elseif strcmp(distribution,'niagara_big')
a=0.7; %leackage scaling factor
L01_D01=struct('name','L2','layer',current_source_layer, 'length',3000, 'width',6500, 'x', 0, 'y',8500, 'power', 1.9/a ); %[1.9 6.09e-2 2.5312 1.8946 1.2436]);
L01_D02=struct('name','L2','layer',current_source_layer, 'length',3000, 'width',6500, 'x', 0, 'y', 0, 'power', 1.9/a); %[1.9 2.476000e+000 1.259800e+000 1.386600e+000 1.046600e+000]);
L01_D03=struct('name','L2','layer',current_source_layer, 'length',3000, 'width',6500, 'x', 11000, 'y', 8500, 'power', 1.9/a); %[1.9 1.054000e+000 1.041300e+000 6.410000e-002 9.169000e-001]);
L01_D04=struct('name','L2','layer',current_source_layer, 'length',3000, 'width',6500, 'x', 11000, 'y', 0, 'power', 1.9/a); %[1.9 5.981000e-001 1.814600e+000 2.530000e+000 2.379500e+000]);
L01_D05=struct('name','Buf','layer',current_source_layer, 'length',2750, 'width',2000, 'x', 0, 'y', 6500, 'power', 1/a); %[1 1.919700e+000 1.824800e+000 1.968200e+000 1.000600e+000]);
L01_D06=struct('name','Buf','layer',current_source_layer, 'length',2750, 'width',2000, 'x', 11250, 'y', 6500, 'power', 1/a); %[1 1.475600e+000 1.699600e+000 1.716000e+000 1.567900e+000 ]);
L01_D07=struct('name','Tag','layer',current_source_layer, 'length',3000, 'width',1500, 'x', 3000, 'y', 8500, 'power', 0.7/a); %[0.7 3.930000e-001 7.300000e-003 4.172000e-001 7.400000e-002]);
L01_D08=struct('name','Tag','layer',current_source_layer, 'length',3000, 'width',1500, 'x', 3000, 'y', 5000, 'power', 0.7/a); %[0.7 3.230000e-002 1.123000e-001 3.391000e-001 5.403000e-001 ]);
L01_D09=struct('name','Tag','layer',current_source_layer, 'length',3000, 'width',1500, 'x', 8000, 'y', 8500, 'power', 0.7/a); %[0.7 5.682000e-001 8.085000e-001 6.984000e-001 4.819000e-001 ]);
L01_D010=struct('name','Tag','layer',current_source_layer, 'length',3000, 'width',1500, 'x', 8000, 'y', 5000, 'power', 0.7/a); %[0.7 7.311000e-001 7.916000e-001 8.568000e-001 7.158000e-001 ]);
L01_D011=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 3000, 'y', 10000, 'power', 3.3/a); %[3.3 1.731200e+000 3.534300e+000 1.916600e+000 2.187500e+000 ]);%Unit: C7
L01_D012=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 3000, 'y', 0, 'power', 3.3/a); %[3.3 5.463000e-001 2.458400e+000 1.458900e+000 4.779800e+000 ]);%Unit: C8
L01_D013=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 5000, 'y', 10000, 'power', 3.3/a); %[3.3 1.326900e+000 2.875900e+000 4.589800e+000 1.132600e+000 ]);%Unit: C9
L01_D014=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 5000, 'y', 0, 'power', 3.3/0.7); %[3.3 4.969300e+000 2.933800e+000 1.151100e+000 2.800200e+000 ]);%Unit: C10
L01_D015=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 7000, 'y', 10000, 'power', 3.3/a); %[3.3 3.297100e+000 3.617400e+000 2.729700e+000 3.000000e-004 ]);%Unit: L2_1
L01_D016=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 7000, 'y', 0, 'power', 3.3/a); %[3.3 1.169700e+000 1.871900e+000 2.993400e+000 1.699700e+000 ]);%Unit: L2_2
L01_D017=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 9000, 'y', 10000, 'power',3.3/a); %[3.3 3.938300e+000 3.969100e+000 5.080300e+000 3.350000e-002 ]);%Unit: L2_3
L01_D018=struct('name','Core','layer',current_source_layer, 'length',2000, 'width',5000, 'x', 9000, 'y', 0, 'power', 3.3/a); %[3.3 7.482000e-001 2.252200e+000 4.525900e+000 1.655800e+000 ]);%Unit: L2_4
L01_D019=struct('name','CrossBar','layer',current_source_layer, 'length',6500, 'width',2000, 'x', 3750, 'y', 6500, 'power', 3.8/a); %[3.8 4.126900e+000 2.031000e-001 4.156300e+000 3.349900e+000 ]);%Unit: L2_5
L01_D020=struct('name','FPU','layer',current_source_layer, 'length',1000, 'width',2000, 'x', 10250, 'y', 6500, 'power', 0.7/a); %[0.700 3.733000e-001 8.082000e-001 1.575600e+000 1.525600e+000 ]);%Unit: L2_6
L01_D021=struct('name','Mem','layer',current_source_layer, 'length',2000, 'width',1500, 'x', 6000, 'y', 8500, 'power', 0.2/a); %[0.2 6.240000e-002 8.900000e-002 2.669000e-001 2.168000e-001 ]);%Unit: L2_7
L01_D022=struct('name','Mem','layer',current_source_layer, 'length',2000, 'width',1500, 'x', 6000, 'y', 5000, 'power', 0.2/a); %[0.2 1.393000e-001 1.903000e-001 3.133000e-001 3.624000e-001 ]);%Unit: L2_8
L01_D023=struct('name','Clk','layer',current_source_layer, 'length',1000, 'width',2000, 'x', 2750, 'y', 6500, 'power', 0.13/a); %[0.13 1.802000e-001 4.310000e-002 1.221000e-001 1.296000e-001 ]);%Unit: CROSSBAR1

L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','CrossBar','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','FPU','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','Mem','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Clk','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);

 elseif strcmp(distribution,'niagara_core_4port')
    if strcmp(benchmark_trace,'http20')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http20-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'http40')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http40-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'http20sql')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http20-sql1001M-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'http20wait')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http20wait-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'sql100')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/sql-100-1M-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'mp4')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/mp4-vidbig3-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'mp4vidbig3')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/mp4vidbig3-http515-mpstat-trace.txt');
    else
        disp('Niagara benchmark file not found!');
        break;
    end

n_slots=size(trace_data,1);
trace_data=trace_data*(3.3/(100*0.7));
x_offset=500;

L01_D01=struct('name','Core 0','layer',current_source_layer, 'length',2400, 'width',4500.0, 'x', 0+x_offset, 'y', 0, 'power', trace_data(:,1));
L01_D02=struct('name','Core 1','layer',current_source_layer, 'length',2400, 'width',4500.0, 'x', 2400+x_offset, 'y', 0, 'power', trace_data(:,1));
L01_D03=struct('name','Core 2','layer',current_source_layer, 'length',2400, 'width',4500.000, 'x', 5200+x_offset, 'y', 0, 'power', trace_data(:,1));
L01_D04=struct('name','Core 3','layer',current_source_layer, 'length',2400, 'width',4500.000, 'x', 7600+x_offset, 'y', 0, 'power', trace_data(:,1));
L01_D05=struct('name','Core 4','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 0+x_offset, 'y', 6500, 'power', trace_data(:,1));
L01_D06=struct('name','Core 5','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 2400+x_offset, 'y', 6500, 'power', trace_data(:,1));
L01_D07=struct('name','Core 6','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 5200+x_offset, 'y', 6500, 'power', trace_data(:,1));
L01_D08=struct('name','Core 7','layer',current_source_layer, 'length',2400, 'width',4500, 'x', 7600+x_offset, 'y', 6500, 'power', trace_data(:,1));
L01_D09=struct('name','Cross Bar','layer',current_source_layer, 'length',4400, 'width',2000, 'x', 2800+x_offset, 'y', 4500, 'power', 3.8*ones(n_slots,1));
L01_D010=struct('name','FPU','layer',current_source_layer, 'length',1000.000, 'width',2000.000, 'x', 7200+x_offset, 'y', 4500.000, 'power', 0.7*ones(n_slots,1));
L01_D011=struct('name','Mem_0','layer',current_source_layer, 'length', 1800, 'width', 2000, 'x',0+x_offset,'y',4500, 'power',0.2*ones(n_slots,1));
L01_D012=struct('name','Mem_1','layer',current_source_layer, 'length', 1800, 'width', 2000, 'x',8200+x_offset,'y',4500, 'power',0.2*ones(n_slots,1));
L01_D013=struct('name','CLK','layer',current_source_layer, 'length', 1000, 'width',2000, 'x',1800+x_offset,'y',4500, 'power',0.13*ones(n_slots,1));


L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);



elseif strcmp(distribution,'niagara_memory_4port')
    
    if strcmp(benchmark_trace,'http20')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http20-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'http40')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http40-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'http20sql')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http20-sql1001M-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'http20wait')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/http20wait-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'sql100')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/sql-100-1M-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'mp4')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/mp4-vidbig3-mpstat-trace.txt');
    elseif strcmp(benchmark_trace,'mp4vidbig3')
        trace_data=textread('./Niagara_Power_Traces_Mohamed/mp4vidbig3-http515-mpstat-trace.txt');
    else
        disp('Niagara benchmark file not found!');
        break;
    end

n_slots=size(trace_data,1);
x_offset=500;

L01_D01=struct('name','L2_0','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 0+x_offset, 'y',0.000, 'power', 1.9*ones(n_slots,1));
L01_D02=struct('name','L2_1','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 6500+x_offset, 'y', 0.000, 'power', 1.9*ones(n_slots,1));
L01_D03=struct('name','L2_2','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 0+x_offset, 'y', 5500.000, 'power', 1.9*ones(n_slots,1));
L01_D04=struct('name','L2_3','layer',current_source_layer, 'length',3500.000, 'width',5500.000, 'x', 6500+x_offset, 'y', 5500.000, 'power', 1.9*ones(n_slots,1));
L01_D05=struct('name','Buf 0','layer',current_source_layer, 'length',2800.000, 'width',1900.000, 'x', 3700+x_offset, 'y', 5500.000, 'power', 1*ones(n_slots,1));
L01_D06=struct('name','Buf 1','layer',current_source_layer, 'length',2800.000, 'width',1900.000, 'x', 3500+x_offset, 'y', 3600.000, 'power', 1*ones(n_slots,1));
L01_D07=struct('name','Tag 01','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500+x_offset, 'y', 0, 'power', 0.7*ones(n_slots,1));
L01_D08=struct('name','Tag 11','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500+x_offset, 'y', 1800, 'power', 0.7*ones(n_slots,1));
L01_D09=struct('name','Tag 21','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500+x_offset, 'y', 7400, 'power', 0.7*ones(n_slots,1));
L01_D010=struct('name','Tag 31','layer',current_source_layer, 'length',3000.000, 'width',1800.000, 'x', 3500+x_offset, 'y', 9200, 'power', 0.7*ones(n_slots,1));

L01_D011=struct('name','C7','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 4.000);%Unit: C7
L01_D012=struct('name','C8','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -6600.000, 'y', -3000.000, 'power', 4.000);%Unit: C8
L01_D013=struct('name','C9','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -3000.000, 'y', -3000.000, 'power', 4.000);%Unit: C9
L01_D014=struct('name','C10','layer',current_source_layer, 'length',1800.000, 'width',1800.000, 'x', -7800.000, 'y', -3000.000, 'power', 4.000);%Unit: C10
L01_D015=struct('name','L2_1','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_1
L01_D016=struct('name','L2_2','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_2
L01_D017=struct('name','L2_3','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_3
L01_D018=struct('name','L2_4','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -4800.000, 'power', 0.700);%Unit: L2_4
L01_D019=struct('name','L2_5','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -1200.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_5
L01_D020=struct('name','L2_6','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -3000.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_6
L01_D021=struct('name','L2_7','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -4800.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_7
L01_D022=struct('name','L2_8','layer',current_source_layer, 'length',1800.000, 'width',1200.000, 'x', -6600.000, 'y', -1800.000, 'power', 0.700);%Unit: L2_8
L01_D023=struct('name','Cross1','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4000.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR1
L01_D024=struct('name','Cross2','layer',current_source_layer, 'length',4800.000, 'width',1800.000, 'x', -4800.000, 'y', -3000.000, 'power', 0.900);%Unit: CROSSBAR2
L01_D025=struct('name','core9','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D026=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D027=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D028=struct('name','core10','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D029=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D030=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D031=struct('name','core11','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D032=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D033=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D034=struct('name','core12','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D035=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D036=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D037=struct('name','core13','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D038=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D039=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D040=struct('name','core14','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D041=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D042=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D043=struct('name','core15','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D044=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D045=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D046=struct('name','core16','layer',current_source_layer, 'length', 1800, 'width',1800, 'x',108000,'y',-5646000, 'power',0);
L01_D047=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);
L01_D048=struct('name','Mem','layer',current_source_layer, 'length', 600, 'width', 600, 'x',108000,'y',-5646000, 'power',0);


 


else
    disp('error with source dist name');



end


d{1}=L01_D01;
d{2}=L01_D02;
d{3}=L01_D03;
d{4}=L01_D04;
d{5}=L01_D05;
d{6}=L01_D06;
d{7}=L01_D07;
d{8}=L01_D08;
d{9}=L01_D09;
d{10}=L01_D010;
d{11}=L01_D011;
d{12}=L01_D012;
d{13}=L01_D013;
d{14}=L01_D014;
d{15}=L01_D015;
d{16}=L01_D016;
d{17}=L01_D017;
d{18}=L01_D018;
d{19}=L01_D019;
d{20}=L01_D020;
d{21}=L01_D021;
d{22}=L01_D022;
d{23}=L01_D023;
d{24}=L01_D024;
d{25}=L01_D025;
d{26}=L01_D026;
d{27}=L01_D027;
d{28}=L01_D028;
d{29}=L01_D029;
d{30}=L01_D030;
d{31}=L01_D031;
d{32}=L01_D032;
d{33}=L01_D033;
d{34}=L01_D034;
d{35}=L01_D035;
d{36}=L01_D036;
d{37}=L01_D037;
d{38}=L01_D038;
d{39}=L01_D039;
d{40}=L01_D040;
d{41}=L01_D041;
d{42}=L01_D042;
d{43}=L01_D043;
d{44}=L01_D044;
d{45}=L01_D045;
d{46}=L01_D046;
d{47}=L01_D047;
d{48}=L01_D048;











