%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################
%THERMAL CONDUCTIVITY IN W/(um K)
%THERMAL SPECIFIC HEAT CAPACITY IN J/(um^3 K)

%% METAL LAYER = 50% SIO2 + 50% COPPER
mat_name='metal';
mat_k=2.0119e-004; %k_sio2 = 1.38e-6, k_cu=401e-6
mat_sc=2.5465e-012; %sc_sio2=1.6539e-012 , sc_cu=3.4392e-12
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];


%% SILICON
%conductivity of silicon equation: 295-0.491 T  (where T is the temperature in kelvin... equation must be further checked)

mat_name='silicon';
mat_k=1.3684e-4;
mat_sc=1.63566e-12 ;
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];



%% BEOL

mat_name='beol';
mat_k=2.25e-6;
mat_sc=2.1745e-12 ;
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];



%% GLUE --> SAME AS TIM FOR NOW
mat_name='glue';
mat_k=4e-6; 
mat_sc=4e-012; 
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];


%% THERMAL INTERFACE MATERIAL

mat_name='tim';
mat_k=22e-6; 
mat_sc=4e-012; 
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];

%% PYREX GLASS SEAL

mat_name='pyrex';
mat_k=1.4e-6; 
mat_sc=4e-012; 
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];

%% COPPER
mat_name='copper';
mat_k=401e-6; 
mat_sc=3.4392e-012; 
mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
material_set=[material_set; mat_cur];


% % %% HEAT SPREADER --> ASSUMES COPPER
% % 
% % mat_name='heatspread';
% % mat_k=401e-6;
% % mat_sc=3.4392e-12;
% % mat_cur=struct('name',mat_name,'k',mat_k,'sc',mat_sc);
% % material_set=[material_set; mat_cur];
% % 

