%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################

if ~isempty(transient_flp_elements_die)
    n_transient_flp_elements_die=size(transient_flp_elements_die,1);
    transient_flp_elements_struct=[];
    for j=1:n_transient_flp_elements_die

        die_cur=transient_flp_elements_die(j).name;
        i=-1;
        for k=1:n_layers
            if strcmp(die_cur,die_set(k).name);
                i=tot_source_layers(k);
                break;
            end
        end
        if i==-1
            disp('Die meant for printing transient temperature data of FLP elements on file not found!');
            die_cur
            continue;
        end

        n_elements_per_die=0;
        cell_numbers_per_element_struct=[];
        
        file_cur=transient_flp_elements_die(j).filename;
        fcur=fopen(file_cur,'w');

        fprintf(fcur,'Time \t');
        print_name=horzcat(die_cur,'.');       
        
        for count_src=1:n_sources
            if source_dimen(count_src).layer==i
                n_elements_per_die=n_elements_per_die+1;
                
                cur_element=source_dimen(count_src).name;
                fprintf(fcur,'%s \t',horzcat(print_name,cur_element));
                
                temp=[];
                count_h=i;
                for count_w=1:n_w
                    for count_l=1:n_l
                        count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;
                        if cell_info(count_cell).src_number==count_src
                            temp=[temp count_cell];
                            continue;
                        end
                    end
                end
                cell_numbers_per_element_struct=[cell_numbers_per_element_struct; struct('list',temp)];
                
                
            end
        end
        
        fprintf(fcur,'\n');
        fclose(fcur);
        
        transient_flp_elements_struct=[transient_flp_elements_struct; struct('n_elements',n_elements_per_die,'cell_numbers',cell_numbers_per_element_struct)];
        
    end
end


if ~isempty(snapshot_die_on_file)
        
        
        n_snapshot_die=size(snapshot_die_on_file,1);
        
        for j=1:n_snapshot_die
            die_cur=snapshot_die_on_file(j).name;
            i=-1;
            for k=1:n_layers
                if strcmp(die_cur,die_set(k).name);
                    i=k;
                    break;
                end
            end
            if i==-1
                disp('Die meant for snapshot not found!');
                die_cur
                continue;
            end
            
            fcur=fopen(snapshot_die_on_file(j).filename,'w');
            fclose(fcur);
        end
    end