%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################
%Paints the floorplan
min_z = min(die_min);
my_z = max(die_max)+5;
 
    for n=1:n_sources
        if source_dimen(n).layer == tot_source_layers(i)
            my_layer = source_dimen(n).layer;
            position_x = source_dimen(n).x;
            position_y = source_dimen(n).y;
            floor_width = source_dimen(n).width;
            floor_length = source_dimen(n).length;
            if(position_x<=L_size && position_y<=W && position_x>=0 && position_y>=0)
                line([position_x,position_x+floor_length],[position_y,position_y],[my_z,my_z],'LineWidth',3,'Color','k')
                line([position_x,position_x],[position_y,position_y+floor_width],[my_z,my_z],'LineWidth',3,'Color','k')
                line([position_x,position_x+floor_length],[position_y+floor_width,position_y+floor_width],[my_z,my_z],'LineWidth',3,'Color','k')
                line([position_x+floor_length,position_x+floor_length],[position_y,position_y+floor_width],[my_z,my_z],'LineWidth',3,'Color','k')


                my_string=source_dimen(n).name;
                my_string_pos_x=mean([position_x position_x+floor_length])-500; %mean(position_x,position_x+floor_length)-300;
                my_string_pos_y=mean([position_y position_y+floor_width]); %-300; %mean(position_y,position_y+floor_width)-300;
                
%                 element = ceil(n/3);
%                 switch mod(n-1,3)
%                     case 0
%                         my_string = sprintf('Core%d',element);
%                     case 1
%                         my_string = sprintf('D%d',element);
%                     case 2
%                         my_string = sprintf('I%d',element);
%                 end
                text(my_string_pos_x,my_string_pos_y,my_z,my_string,'FontName','ArialBlack','FontSize',16,'FontWeight','bold','Color','k') 
                hold on;        
            end
        end

    end
    axis([0 L_size 0 W])
    hold off
