%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################

 if (analysis_type==transient && ~isempty(transient_flp_elements_die))
    n_transient_flp_elements_die=size(transient_flp_elements_die,1);
    
    for j=1:n_transient_flp_elements_die
        
        file_cur=transient_flp_elements_die(j).filename;
        
        fcur=fopen(file_cur,'a');
        
        n_elements_cur=transient_flp_elements_struct(j).n_elements;
        for tp=1:ntp_slot-1
            time_cur=time(ntp_final_prev+tp);
            fprintf(fcur,'%f \t',time_cur);
            for count_el=1:n_elements_cur;
                temp_cur=mean(X_slot(transient_flp_elements_struct(j).cell_numbers(count_el).list,tp));
                fprintf(fcur,'%f \t',temp_cur);
            end
            fprintf(fcur,'\n');
        end
                
        fclose(fcur);
    end
 end
 
 if ~isempty(snapshot_die_on_file)
        
        
        n_snapshot_die=size(snapshot_die_on_file,1);
        
        for j=1:n_snapshot_die
            die_cur=snapshot_die_on_file(j).name;
            i=-1;
            for k=1:n_layers
                if strcmp(die_cur,die_set(k).name);
                    i=k;
                    break;
                end
            end
            if i==-1
                continue;
            end
            
            fcur=fopen(snapshot_die_on_file(j).filename,'a');
            count_h=tot_source_layers(i);
            for tp=1:ntp_slot-1
                for count_w=1:n_w
                    for count_l=1:n_l
                        count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;
                        fprintf(fcur,'%f ',X_slot(count_cell,tp));
                    end
                    fprintf(fcur,'\n');
                end
            end
            fclose(fcur);
        end
    end