%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################
X0=X;
error=100;
error_change_percentage=100;

iter=0;
iter_set=[];
error_steady=[];


while error>error_tolerance && iter<=max_iter && error_change_percentage>1
    iter=iter+1
    steady_put_sources;
    X=solve_with_lu(G,U+Utop+Ubottom+Ueast+Uwest+Ua);
    
    check_vapor_quality;
    if simulation_terminated_flag
        calculate_heat_out;
        heat_in=total_heat
        heat_out
        plot_results_for_debugging;
        break;
    end
            
    Psat_prev=Psat;
    Tsat_prev=Tsat;

    
    % Updating channel parameters
    for count_channel_layer=1:n_channel_layers
        count_h=tot_channel_layers(count_channel_layer);
        for count_l=2:2:(n_l-1)
            count_channel=(count_channel_layer-1)*n_channels+(count_l/2);
            for count_w=1:n_w
               count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;
               build_channel_cell_info;
               cell_info(count_cell).north=g_north;
               cell_info(count_cell).south=g_south;
               cell_info(count_cell).east=g_east;
               cell_info(count_cell).west=g_west;
               cell_info(count_cell).top=g_top;
               cell_info(count_cell).bottom=g_bottom;
               cell_info(count_cell).cap=cap;
            end
        end
    end
    for count_channel_layer=1:n_channel_layers
        count_h=tot_channel_layers(count_channel_layer);
        for count_l=2:2:(n_l-1)
            count_channel=(count_channel_layer-1)*n_channels+(count_l/2);
            for count_w=1:n_w
               count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;
               build_channel_system_matrices_mc4rm;
            end
        end
    end
    error=norm(abs(X-X0))/norm(X);
    if iter==1 % exception for ploting
        iter_set=iter;
        error_steady=error;
        figure(1);
        error_h=semilogy(iter_set,error_steady);
        set(error_h,'XDataSource','iter_set');
        set(error_h,'YDataSource','error_steady');
        xlabel('Iteration Number');
        ylabel('Error Norm');
        title('Error Norm Evolution');
        pause(1);

    else
        error_change_percentage=abs(error-error_steady(length(error_steady)))*100/error;
        iter_set=[iter_set iter];
        error_steady=[error_steady error];

        refreshdata(error_h);
        pause(1);
    end
    %         if iter==4 % resetting error plot data after 3 iterations to display only useful part of the convergence
    %             iter_set=iter_set(3:4);
    %             error_steady=error_steady(3:4);
    %             refreshdata(error_h);
    %             pause(1);
    %         end
    X0=X;
end