%  ##############################################################################
%  # This file is part of STEAM, version 1.0 (pre-alpha) .                      #
%  #                                                                            #
%  # STEAM is free software: you can  redistribute it and/or  modify it  under  #
%  # the terms of the  Ecliplse Publice License as  published by the            #
%  # Eclipse  Foundation, version 1.0.                                          #
%  #                                                                            #
%  # STEAM is  distributed  in the hope  that it will  be useful, but  WITHOUT  #
%  # ANY  WARRANTY; without  even the  implied warranty  of MERCHANTABILITY  or #
%  # FITNESS  FOR A PARTICULAR  PURPOSE. See the Eclipse Public License for     #
%  # more details. Visit <http://www.eclipse.org/legal/epl-v10.html>.           #
%  #                                                                            #
%  #                             Copyright (C) 2014                             #
%  #   Embedded Systems Laboratory - Ecole Polytechnique Federale de Lausanne   #
%  #                            All Rights Reserved.                            #
%  #                                                                            #
%  # Authors: Arvind Sridhar                                                    #
%  #          David Atienza                                                     #
%  #                                                                            #
%  # For any comment, suggestion or request  about STEAM, please  contact       #
%  #                                                                            #
%  # EPFL-STI-IEL-ESL                                                           #
%  # Batiment ELG, ELG 130                                                      #
%  # Station 11                                                                 #
%  # 1015 Lausanne, Switzerland           Url  : http://esl.epfl.ch/STEAM       #
%  ##############################################################################
X0=X;





   clear source_factor;
    
        
    Ua=zeros(n_cells,1);

    for layer_count=1:n_layers
        count_h=tot_source_layers(layer_count);

        for count_w=1:n_w
            for count_l=1:n_l
                count_cell=(count_h-1)*n_a+(count_w-1)*n_l+count_l;
                
                src_count=cell_info(count_cell).src_number;
                if src_count~=0


                    source_factor=cell_info(count_cell).src_factor;

                    amp=source_dimen(src_count).power(1)*source_factor;
                    



                    X_src=X(count_cell); %Temperature before 
                    delT=X_src-293.15; %In celsius
                    delT0=Tamb-293.15; %Ambient Temperature in celsius


                    amp_temp=amp;%*(1+heater_alpha*delT)/(1+heater_alpha*delT0);

                    Ua(count_cell)=Ua(count_cell)+amp_temp;
                end
            end
        end


    end
